# $Header: /alx-cvs/alx-src/tinyalxconfig-ng/functions/config_auth.sh,v 1.4 2008/06/06 23:21:49 niro Exp $
# configures the system authentification via mysql db settings

set_shadow_pass()
{
	local user="$1"
	local pass="$2"
	[[ -z ${user} ]] && return 1
	[[ -z ${pass} ]] && return 1

	# NULL is forbidden too!
	[[ ${pass} = NULL ]] && return 1

	# update pass
	(echo "${pass}"; sleep 1; echo "${pass}") | passwd ${user} &> /dev/null
	return 0
}

set_vnc_pass()
{
	local user="$1"
	local pass="$2"

	[[ -z ${user} ]] && return 1
	[[ -z ${pass} ]] && return 1

	# NULL is forbidden too!
	[[ ${pass} = NULL ]] && return 1

	local homedir=/home/${user}
	[[ ${user} = root ]] && homedir=/${user}

	# pipe it 2x; 1st for new pw, 2nd to validate
	HOME="${homedir}" vncpasswd &> /dev/null << EOF
${pass}
${pass}
EOF
}

config_auth()
{
	# first of all get the vars
	evaluate_table_xml client_auth

	set_shadow_pass	root "${client_auth_shell}"
	set_shadow_pass "${ALX_UNPRIV_USER}" "${client_auth_station}"

	# vnc passwd (min 6 chars)
	set_vnc_pass root "${client_auth_vnc}"
}
